/** @file KBuffer.h
* Data buffer to encapsulate copy-on-write functionality
*
*	K3dEngine 1.0 - OpenGL Game Engine
*	http://sourceforge.net/projects/kengine/
*
* 06.03.21 - First version
*
*
*/

#pragma once

namespace K3d
{
#define K_BUFFER_SIZE 256
	
	class CBuffer
    {
		size_t  m_tSize;
        char*   m_strData;
    public:
        CBuffer() : m_tSize(0), m_strData(0)   {}
        CBuffer(const char* _strData, size_t _tSize)
            : m_tSize(_tSize), m_strData(new char[_tSize])
        { 
			memcpy(m_strData, _strData, m_tSize); 
		}
        CBuffer(const CBuffer& _rBuf) : m_tSize(_rBuf.m_tSize), m_strData(new char[m_tSize])
        { 
			memcpy(m_strData, _rBuf.m_strData, m_tSize); 
		}
        ~CBuffer()   
		{ 
			delete[] m_strData; 
		}
        void operator=(const CBuffer& _rBuf)
        {
            delete[] m_strData;
            m_tSize = _rBuf.m_tSize;
            m_strData = new char[m_tSize];
            memcpy(m_strData, _rBuf.m_strData, m_tSize);
        }
        const char* GetData() const    
		{ 
			return m_strData; 
		}
    };
}



