/** @file KScanner.cpp
* Converts a string into an array of meaningful values
*
*	K3dEngine 1.0 - OpenGL Game Engine
*	http://sourceforge.net/projects/kengine/
*
* 06.03.22 - First version
*
*/

#include "stdafx.h"	
using namespace K3d;


///\brief Scanning script line
///\param _rstrLine Reference to string line
///\retval bool True if string line is scanned
bool CScanner::ScanLine(const std::string& _rLine)
{
    // Reset offset and token buffer
    m_tOffset = 0;
    m_tTokArray.clear();

    // Check for an empty line
    if (_rLine.empty())
        return false;

    // Check for valid line content
    if (!SkipSpacing(_rLine))
        return false;

    // Check for a valid opcode
    if (!ScanCode(_rLine))
        return false;

    size_t tLen = _rLine.length();
	// Scan args until the end of line
    while (m_tOffset < tLen)   
    {
        // Get to next arg
		if (!SkipSpacing(_rLine)) 
            return true;        // Unless we're done
        if (!ScanNum(_rLine))
            return false;
    }

    return true;
}

