/** @file KScript.h
* Basic script, currently just encapsulating an arrayed list of instructions
*
*	K3dEngine 1.0 - OpenGL Game Engine
*	http://sourceforge.net/projects/kengine/
*
* 05.09.15 - First version
* 06.03.16 - Linux version
*
*/

#pragma once

namespace K3d
{

#define K_NUM_VARIABLES 8


	class CScript
	{
		std::vector<CInstruction> m_vInstruction;	///< Instruction array
		size_t m_tNumVars;	///< Number of variables
	public:
		///\brief Constructor
		///\param _rvInstruction Reference to instruction array
		///\param _tNumVars Number of variables
		CScript(const std::vector<CInstruction>& _rvInstruction, size_t _tNumVars)
			: m_vInstruction(_rvInstruction), m_tNumVars(_tNumVars) {}		
		~CScript(){}
		
		///\brief Get instruction array
		///\retval m_vInstruction[0] Instruction array
		const CInstruction* GetInstruction() const 
		{
			return &m_vInstruction[0]; 
		}
		///\brief Get number of variables
		///\retval m_tNumVar Nuber of variables
		int GetNumVars() const
		{ 
			return (int) m_tNumVars; 
		}
	};
}	/// End namespace K3d
