/** @file KScriptState.h
* A script's executional state
*
*	K3dEngine 1.0 - OpenGL Game Engine
*	http://sourceforge.net/projects/kengine/
*
* 06.03.16 - First version
*
*/

#pragma once

namespace K3d
{
    class CScriptState
    {
		std::vector<char>   m_vVarData;	///< Char variable data array
    public:
        ///\brief Set data size
		///\param tSize Data size
        void SetDataSize(size_t _tSize)
		{
			 m_vVarData.resize(_tSize); 
		}

        ///\brief Set variable
		///\param _tSize Variable size
		///\param _cVal Char variable
        void SetVar(size_t _tSize, char _cVal) 
		{
			assert(_tSize < m_vVarData.size()); 
			m_vVarData[_tSize] = _cVal; 
		}
		///\brief Get variable
		///\param _tSize Variable size
		///\retval m_vVarData[_tSize] Char variable
        char GetVar(size_t _tSize) const
		{
			assert(_tSize < m_vVarData.size());
			return m_vVarData[_tSize]; 
		}
		///\brief Get variable data array
		///\retval m_vVarData Char variable data array
        const std::vector<char>& GetDataArray() const  
		{ 
			return m_vVarData; 
		}
    };
}
